=== debian/changelog ===
plastimatch (1.10.0+dfsg.1-1) unstable; urgency=medium

  * [8e67811] New upstream version 1.10.0+dfsg.1
  * [f037548] Remove obsolete patches

 -- Steve M. Robbins <smr@debian.org>  Wed, 12 Feb 2025 22:48:49 -0600

plastimatch (1.9.4+dfsg.1-3) unstable; urgency=medium

  * Team upload
  * Removing obsolete RTSTRUCT DICOM tags to build against DCMTK/3.6.8
    (Closes: #1075793)
  * Raising Standards version to 4.7.0 (no change)
  * Fixing d/watch file after change in Gitlab's layout

 -- Pierre Gruet <pgt@debian.org>  Fri, 26 Jul 2024 10:31:35 +0200

plastimatch (1.9.4+dfsg.1-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [1932578] Build using C++17 (required for dcmtk).  Closes: #1039903.

 -- Steve M. Robbins <smr@debian.org>  Thu, 29 Jun 2023 11:38:50 -0500
